diff --git a/game/core/src/main/java/net/minecraft/core/world/chunk/Chunk.java b/game/core/src/main/java/net/minecraft/core/world/chunk/Chunk.java
index 384d6a824..f32271393 100644
--- a/game/core/src/main/java/net/minecraft/core/world/chunk/Chunk.java
+++ b/game/core/src/main/java/net/minecraft/core/world/chunk/Chunk.java
@@ -9,21 +9,23 @@ import net.minecraft.core.block.Blocks;
 import net.minecraft.core.block.entity.TileEntity;
 import net.minecraft.core.entity.Entity;
 import net.minecraft.core.util.helper.MathHelper;
-import net.minecraft.core.util.phys.AABB;
 import net.minecraft.core.world.World;
 import net.minecraft.core.enums.LightLayer;
 import net.minecraft.core.world.biome.Biome;
 import net.minecraft.core.world.pos.ChunkPos;
+import net.minecraft.core.world.pos.ChunkPosc;
+import net.minecraft.core.world.pos.ChunkSectionTilePos;
 import net.minecraft.core.world.pos.ChunkTilePos;
+import net.minecraft.core.world.pos.ChunkTilePosc;
 import net.minecraft.core.world.pos.TilePos;
 import org.jetbrains.annotations.NotNull;
 import org.jetbrains.annotations.Nullable;
+import org.joml.primitives.AABBdc;
 import org.slf4j.Logger;
 
 import java.util.*;
 
-public class Chunk
-{
+public class Chunk {
     private static final Logger LOGGER = LogUtils.getLogger();
     public static final int CHUNK_SIZE_X = 16;
     public static final int CHUNK_SIZE_Z = 16;
@@ -47,9 +49,9 @@ public class Chunk
     public long lastSaveTime = 0L;
     protected final @NotNull ChunkSection @NotNull [] sections = new ChunkSection[CHUNK_SECTIONS];
 
-    public Chunk(final @NotNull World world, final @NotNull ChunkPos pos) {
+    public Chunk(final @NotNull World world, final @NotNull ChunkPosc pos) {
         this.world = world;
-        this.pos = pos;
+        this.pos = new ChunkPos(pos);
 
         for (int i = 0; i < this.sections.length; i++) {
             this.sections[i] = new ChunkSection(this, i);
@@ -61,8 +63,8 @@ public class Chunk
         this(world, new ChunkPos(x, z));
     }
 
-    public static int makeBlockIndex(final @NotNull ChunkTilePos chunkTilePos) {
-        return (chunkTilePos.y * CHUNK_SIZE_Z * CHUNK_SIZE_X) + (chunkTilePos.z * CHUNK_SIZE_X) + chunkTilePos.x;
+    public static int makeBlockIndex(final @NotNull ChunkTilePosc chunkTilePos) {
+        return (chunkTilePos.y() * CHUNK_SIZE_Z * CHUNK_SIZE_X) + (chunkTilePos.z() * CHUNK_SIZE_X) + chunkTilePos.x();
     }
 
     @Deprecated
@@ -75,7 +77,7 @@ public class Chunk
         return this.sections[index];
     }
 
-    public @Nullable ChunkSection getSection(final @NotNull ChunkTilePos chunkTilePos) {
+    public @Nullable ChunkSection getSection(final @NotNull ChunkTilePosc chunkTilePos) {
         return this.getSection(chunkTilePos.getSectionIndex());
     }
 
@@ -85,7 +87,7 @@ public class Chunk
         Arrays.fill(this.variety, Double.NEGATIVE_INFINITY);
     }
 
-    public boolean isAtLocation(final @NotNull ChunkPos chunkPos) {
+    public boolean isAtLocation(final @NotNull ChunkPosc chunkPos) {
         return this.pos.equals(chunkPos);
     }
 
@@ -102,25 +104,10 @@ public class Chunk
         this.heightMap[z * CHUNK_SIZE_X + x] = (short) y;
     }
 
-    public void addTick(final @NotNull NextTickListEntry entry) {
-        final @NotNull NextTickListEntry cloned = entry.clone();
-        cloned.x = cloned.x & (CHUNK_SIZE_X - 1);
-        cloned.z = cloned.z & (CHUNK_SIZE_Z - 1);
-        final int pos = NextTickListEntry.compressChunkCoord((short) entry.x, (short) entry.y, (short) entry.z);
-        this.tickList.put(pos, cloned);
-    }
-
-    public void dropTick(final @NotNull NextTickListEntry entry) {
-        final int pos = NextTickListEntry.compressChunkCoord((short) entry.x, (short) entry.y, (short) entry.z);
-        this.tickList.remove(pos);
-    }
-
     public void recalcHeightmapOnly() {
         int acc = 0;
-        for(int x = 0; x < CHUNK_SIZE_X; x++)
-        {
-            for(int z = 0; z < CHUNK_SIZE_Z; z++)
-            {
+        for (int x = 0; x < CHUNK_SIZE_X; x++) {
+            for (int z = 0; z < CHUNK_SIZE_Z; z++) {
                 int y = CHUNK_SECTIONS * ChunkSection.SECTION_SIZE_Y - 1;
                 while (y > 0 && Blocks.lightBlock[getBlockID(x, y - 1, z)] == 0) {
                     y--;
@@ -130,37 +117,34 @@ public class Chunk
             }
         }
 
-        isModified = true;
-        averageBlockHeight = acc / (CHUNK_SIZE_X * CHUNK_SIZE_Z);
+        this.isModified = true;
+        this.averageBlockHeight = acc / (CHUNK_SIZE_X * CHUNK_SIZE_Z);
     }
 
-    public void recalcHeightmapAndLightmap()
-    {
+    public void recalcHeightmapAndLightmap() {
         recalcHeightmapOnly();
 
         // Generate skylight map
-        if (!world.worldType.hasCeiling()) {
-            for(int x = 0; x < CHUNK_SIZE_X; x++)
-            {
-                for(int z = 0; z < CHUNK_SIZE_Z; z++)
-                {
+        if (!this.world.worldType.hasCeiling()) {
+            for (int x = 0; x < CHUNK_SIZE_X; x++) {
+                for (int z = 0; z < CHUNK_SIZE_Z; z++) {
                     int skyLightValue = 15;
                     int lightY = (CHUNK_SECTIONS * ChunkSection.SECTION_SIZE_Y) - 1;
                     do {
                         skyLightValue -= Blocks.lightBlock[getBlockID(x, lightY, z) & 0x3fff];
-                        if(skyLightValue > 0) {
+                        if (skyLightValue > 0) {
                             setBrightness(LightLayer.Sky, x, lightY, z, skyLightValue);
                         }
-                    } while(--lightY > 0 && skyLightValue > 0);
+                    } while (--lightY > 0 && skyLightValue > 0);
                 }
             }
         }
-        isModified = true;
+        this.isModified = true;
     }
 
     public void checkForLightGaps() {
-        for(int x = 0; x < CHUNK_SIZE_X; x++) {
-            for(int z = 0; z < CHUNK_SIZE_Z; z++) {
+        for (int x = 0; x < CHUNK_SIZE_X; x++) {
+            for (int z = 0; z < CHUNK_SIZE_Z; z++) {
                 lightGaps(x, z);
             }
         }
@@ -176,28 +160,26 @@ public class Chunk
         lightGap(worldX, worldZ + 1, y);
     }
 
-    private void lightGap(int x, int z, int y)
-    {
-        int blockHeight = world.getHeightValue(x, z);
-        if(blockHeight > y)
-        {
-            world.scheduleLightingUpdate(LightLayer.Sky, x, y, z, x, blockHeight, z);
-            isModified = true;
-        }
-        else if(blockHeight < y)
-        {
-            world.scheduleLightingUpdate(LightLayer.Sky, x, blockHeight, z, x, y, z);
-            isModified = true;
+    private void lightGap(int x, int z, int y) {
+        int blockHeight = this.world.getHeightValue(x, z);
+        if (blockHeight > y) {
+            this.world.scheduleLightingUpdate(LightLayer.Sky, x, y, z, x, blockHeight, z);
+            this.isModified = true;
+        } else if (blockHeight < y) {
+            this.world.scheduleLightingUpdate(LightLayer.Sky, x, blockHeight, z, x, y, z);
+            this.isModified = true;
         }
     }
 
-    private void recalcHeight(final @NotNull ChunkTilePos tilePos) {
-        final int heightValue = this.getHeightValue(tilePos.x, tilePos.z);
-        final @NotNull ChunkTilePos iPos = new ChunkTilePos(tilePos.x, heightValue, tilePos.z);
-        if(tilePos.y > heightValue) {
-            iPos.y = tilePos.y;
+    private void recalcHeight(final @NotNull ChunkTilePosc tilePos) {
+        final int heightValue = this.getHeightValue(tilePos.x(), tilePos.z());
+        final @NotNull ChunkTilePos iPos = new ChunkTilePos(tilePos.x(), heightValue, tilePos.z());
+        if (tilePos.y() > heightValue) {
+            iPos.y = tilePos.y();
+        }
+        ChunkTilePos queryPos = new ChunkTilePos();
+        for (; iPos.y > 0 && Blocks.lightBlock[this.getBlockId(iPos.down(queryPos)) & 0x3fff] == 0; iPos.y--) {
         }
-        for (; iPos.y > 0 && Blocks.lightBlock[this.getBlockId(iPos.down()) & 0x3fff] == 0; iPos.y--) { }
 
         if (iPos.y == heightValue) {
             return;
@@ -207,7 +189,7 @@ public class Chunk
         this.setHeightValue(iPos.x, iPos.z, iPos.y);
 
         final @NotNull TilePos worldPos = new TilePos(this.pos, tilePos);
-        if(iPos.y < heightValue) {
+        if (iPos.y < heightValue) {
             for (int dy = iPos.y; dy < heightValue; dy++) {
                 this.setBrightness(LightLayer.Sky, iPos.x, dy, iPos.z, World.MAX_BRIGHTNESS);
             }
@@ -223,31 +205,32 @@ public class Chunk
         while (iPos.y > 0 && lightValue > 0) {
             iPos.y--;
             int lightBlock = Blocks.lightBlock[this.getBlockId(iPos)];
-            if(lightBlock == 0) {
+            if (lightBlock == 0) {
                 lightBlock = 1;
             }
             lightValue -= lightBlock;
-            if(lightValue < 0) {
+            if (lightValue < 0) {
                 lightValue = 0;
             }
             this.setBrightness(LightLayer.Sky, iPos, lightValue);
         }
 
-        for(; iPos.y > 0 && Blocks.lightBlock[this.getBlockId(iPos.down())] == 0; iPos.y--) { }
+        for (; iPos.y > 0 && Blocks.lightBlock[this.getBlockId(iPos.down(queryPos))] == 0; iPos.y--) {
+        }
 
-        if(iPos.y != lightY) {
+        if (iPos.y != lightY) {
             this.world.scheduleLightingUpdate(LightLayer.Sky, new TilePos(worldPos.x - 1, iPos.y, worldPos.z - 1), new TilePos(worldPos.x + 1, lightY, worldPos.z + 1));
         }
 
         this.isModified = true;
     }
 
-    public int getBlockId(final @NotNull ChunkTilePos tilePos) {
+    public int getBlockId(final @NotNull ChunkTilePosc tilePos) {
         if (!tilePos.inBounds()) {
             return 0;
         }
 
-        return Objects.requireNonNull(this.getSection(tilePos)).getBlockId(tilePos.toChunkSectionTilePos());
+        return Objects.requireNonNull(this.getSection(tilePos)).getBlockId(new ChunkSectionTilePos(tilePos));
     }
 
     @Deprecated
@@ -255,15 +238,15 @@ public class Chunk
         return this.getBlockId(new ChunkTilePos(x, y, z));
     }
 
-    public @Nullable Block<?> getBlock(final @NotNull ChunkTilePos tilePos) {
+    public @Nullable Block<?> getBlock(final @NotNull ChunkTilePosc tilePos) {
         return Blocks.getBlock(this.getBlockId(tilePos));
     }
 
-    public boolean setBlockIdDataRaw(final @NotNull ChunkTilePos tilePos, final int id, final int data) {
+    public boolean setBlockIdDataRaw(final @NotNull ChunkTilePosc tilePos, final int id, final int data) {
         return this.setBlockIdData(tilePos, id, data, true);
     }
 
-    public boolean setBlockIdData(final @NotNull ChunkTilePos tilePos, final int id, final int data) {
+    public boolean setBlockIdData(final @NotNull ChunkTilePosc tilePos, final int id, final int data) {
         return this.setBlockIdData(tilePos, id, data, false);
     }
 
@@ -273,16 +256,16 @@ public class Chunk
         return this.setBlockIdDataRaw(new ChunkTilePos(x, y, z), id, data);
     }
 
-    private boolean setBlockIdData(final @NotNull ChunkTilePos tilePos, final int id, final int data, final boolean raw) {
+    private boolean setBlockIdData(final @NotNull ChunkTilePosc tilePos, final int id, final int data, final boolean raw) {
         if (!tilePos.inBounds()) {
             return false;
         }
 
         final @NotNull ChunkSection section = Objects.requireNonNull(this.getSection(tilePos));
-        final int heightValue = this.getHeightValue(tilePos.x, tilePos.z);
+        final int heightValue = this.getHeightValue(tilePos.x(), tilePos.z());
 
-        final int currentId = section.getBlockId(tilePos.toChunkSectionTilePos());
-        final int currentData = section.getData(tilePos.toChunkSectionTilePos());
+        final int currentId = section.getBlockId(new ChunkSectionTilePos(tilePos));
+        final int currentData = section.getData(new ChunkSectionTilePos(tilePos));
 
         final @Nullable Block<?> currentBlock = Blocks.getBlock(currentId);
         final @Nullable Block<?> newBlock = Blocks.getBlock(id);
@@ -291,8 +274,8 @@ public class Chunk
             return false;
         }
 
-        section.setBlockId(tilePos.toChunkSectionTilePos(), id);
-        section.setData(tilePos.toChunkSectionTilePos(), data);
+        section.setBlockId(new ChunkSectionTilePos(tilePos), id);
+        section.setData(new ChunkSectionTilePos(tilePos), data);
 
         final @NotNull TilePos worldPos = new TilePos(this.pos, tilePos);
         if (!raw && currentBlock != null && !this.world.isClientSide) {
@@ -301,17 +284,17 @@ public class Chunk
 
         if (!this.world.getWorldType().hasCeiling()) {
             if (Blocks.lightBlock[id & 0x3FFF] != 0) {
-                if (tilePos.y >= heightValue) {
-                    this.recalcHeight(tilePos.up());
+                if (tilePos.y() >= heightValue) {
+                    this.recalcHeight(tilePos.up(new ChunkTilePos()));
                 }
-            } else if (tilePos.y == heightValue - 1) {
+            } else if (tilePos.y() == heightValue - 1) {
                 this.recalcHeight(tilePos);
             }
             this.world.scheduleLightingUpdate(LightLayer.Sky, worldPos);
         }
 
         this.world.scheduleLightingUpdate(LightLayer.Block, worldPos);
-        this.lightGaps(tilePos.x, tilePos.z);
+        this.lightGaps(tilePos.x(), tilePos.z());
 
         if (!raw && newBlock != null) {
             newBlock.onPlacedByWorld(this.world, worldPos);
@@ -326,7 +309,7 @@ public class Chunk
         return this.setBlockIdData(new ChunkTilePos(x, y, z), id, data);
     }
 
-    public boolean setBlockId(final @NotNull ChunkTilePos tilePos, final int id) {
+    public boolean setBlockId(final @NotNull ChunkTilePosc tilePos, final int id) {
         return this.setBlockIdData(tilePos, id, 0);
     }
 
@@ -335,12 +318,12 @@ public class Chunk
         return this.setBlockId(new ChunkTilePos(x, y, z), id);
     }
 
-    public int getBlockData(final @NotNull ChunkTilePos tilePos) {
+    public int getBlockData(final @NotNull ChunkTilePosc tilePos) {
         if (!tilePos.inBounds()) {
             return 0;
         }
 
-        return Objects.requireNonNull(this.getSection(tilePos)).getData(tilePos.toChunkSectionTilePos());
+        return Objects.requireNonNull(this.getSection(tilePos)).getData(new ChunkSectionTilePos(tilePos));
     }
 
     @Deprecated
@@ -348,12 +331,12 @@ public class Chunk
         return this.getBlockData(new ChunkTilePos(x, y, z));
     }
 
-    public boolean setBlockData(final @NotNull ChunkTilePos tilePos, final int value) {
+    public boolean setBlockData(final @NotNull ChunkTilePosc tilePos, final int value) {
         if (!tilePos.inBounds()) {
             return false;
         }
 
-        Objects.requireNonNull(this.getSection(tilePos)).setData(tilePos.toChunkSectionTilePos(), value);
+        Objects.requireNonNull(this.getSection(tilePos)).setData(new ChunkSectionTilePos(tilePos), value);
         this.isModified = true;
 
         return true;
@@ -364,12 +347,12 @@ public class Chunk
         this.setBlockData(new ChunkTilePos(x, y, z), value);
     }
 
-    public @Nullable Biome getBlockBiome(final @NotNull ChunkTilePos tilePos) {
+    public @Nullable Biome getBlockBiome(final @NotNull ChunkTilePosc tilePos) {
         if (!tilePos.inBounds()) {
             return null;
         }
 
-        return Objects.requireNonNull(this.getSection(tilePos)).getBiome(tilePos.toChunkSectionTilePos());
+        return Objects.requireNonNull(this.getSection(tilePos)).getBiome(new ChunkSectionTilePos(tilePos));
     }
 
     @Deprecated
@@ -377,12 +360,12 @@ public class Chunk
         return this.getBlockBiome(new ChunkTilePos(x, y, z));
     }
 
-    public boolean setBlockBiome(final @NotNull ChunkTilePos tilePos, final @NotNull Biome biome) {
+    public boolean setBlockBiome(final @NotNull ChunkTilePosc tilePos, final @NotNull Biome biome) {
         if (!tilePos.inBounds()) {
             return false;
         }
 
-        Objects.requireNonNull(this.getSection(tilePos)).setBiome(tilePos.toChunkSectionTilePos(), biome);
+        Objects.requireNonNull(this.getSection(tilePos)).setBiome(new ChunkSectionTilePos(tilePos), biome);
         this.isModified = true;
 
         return true;
@@ -393,12 +376,12 @@ public class Chunk
         return this.setBlockBiome(new ChunkTilePos(x, y, z), biome);
     }
 
-    public double getBlockTemperature(final @NotNull ChunkTilePos tilePos) {
+    public double getBlockTemperature(final @NotNull ChunkTilePosc tilePos) {
         if (!tilePos.inBounds()) {
             return Double.NEGATIVE_INFINITY;
         }
 
-        return this.temperature[tilePos.x * CHUNK_SIZE_Z + tilePos.z];
+        return this.temperature[tilePos.x() * CHUNK_SIZE_Z + tilePos.z()];
     }
 
     @Deprecated
@@ -406,12 +389,12 @@ public class Chunk
         return this.getBlockTemperature(new ChunkTilePos(x, 0, z));
     }
 
-    public void setBlockTemperature(final @NotNull ChunkTilePos tilePos, final double temperature) {
+    public void setBlockTemperature(final @NotNull ChunkTilePosc tilePos, final double temperature) {
         if (!tilePos.inBounds()) {
             return;
         }
 
-        this.temperature[tilePos.x * CHUNK_SIZE_Z + tilePos.z] = temperature;
+        this.temperature[tilePos.x() * CHUNK_SIZE_Z + tilePos.z()] = temperature;
         this.isModified = true;
     }
 
@@ -425,12 +408,12 @@ public class Chunk
         return true;
     }
 
-    public double getBlockHumidity(final @NotNull ChunkTilePos tilePos) {
+    public double getBlockHumidity(final @NotNull ChunkTilePosc tilePos) {
         if (!tilePos.inBounds()) {
             return Double.NEGATIVE_INFINITY;
         }
 
-        return this.humidity[tilePos.x * CHUNK_SIZE_Z + tilePos.z];
+        return this.humidity[tilePos.x() * CHUNK_SIZE_Z + tilePos.z()];
     }
 
     @Deprecated
@@ -438,12 +421,12 @@ public class Chunk
         return this.getBlockHumidity(new ChunkTilePos(x, 0, z));
     }
 
-    public void setBlockHumidity(final @NotNull ChunkTilePos tilePos, final double humidity) {
+    public void setBlockHumidity(final @NotNull ChunkTilePosc tilePos, final double humidity) {
         if (!tilePos.inBounds()) {
             return;
         }
 
-        this.humidity[tilePos.x * CHUNK_SIZE_Z + tilePos.z] = humidity;
+        this.humidity[tilePos.x() * CHUNK_SIZE_Z + tilePos.z()] = humidity;
         this.isModified = true;
     }
 
@@ -457,12 +440,12 @@ public class Chunk
         return true;
     }
 
-    public double getBlockVariety(final @NotNull ChunkTilePos tilePos) {
+    public double getBlockVariety(final @NotNull ChunkTilePosc tilePos) {
         if (!tilePos.inBounds()) {
             return Double.NEGATIVE_INFINITY;
         }
 
-        return this.variety[tilePos.x * CHUNK_SIZE_Z + tilePos.z];
+        return this.variety[tilePos.x() * CHUNK_SIZE_Z + tilePos.z()];
     }
 
     @Deprecated
@@ -470,12 +453,12 @@ public class Chunk
         return this.getBlockVariety(new ChunkTilePos(x, 0, z));
     }
 
-    public void setBlockVariety(final @NotNull ChunkTilePos tilePos, final double variety) {
+    public void setBlockVariety(final @NotNull ChunkTilePosc tilePos, final double variety) {
         if (!tilePos.inBounds()) {
             return;
         }
 
-        this.variety[tilePos.x * CHUNK_SIZE_Z + tilePos.z] = variety;
+        this.variety[tilePos.x() * CHUNK_SIZE_Z + tilePos.z()] = variety;
         this.isModified = true;
     }
 
@@ -489,12 +472,12 @@ public class Chunk
         return true;
     }
 
-    public int getBrightness(final @NotNull LightLayer lightLayer, final @NotNull ChunkTilePos tilePos) {
+    public int getBrightness(final @NotNull LightLayer lightLayer, final @NotNull ChunkTilePosc tilePos) {
         if (!tilePos.inBounds()) {
             return 0;
         }
 
-        return Objects.requireNonNull(this.getSection(tilePos)).getBrightness(lightLayer, tilePos.toChunkSectionTilePos());
+        return Objects.requireNonNull(this.getSection(tilePos)).getBrightness(lightLayer, new ChunkSectionTilePos(tilePos));
     }
 
     @Deprecated
@@ -502,12 +485,12 @@ public class Chunk
         return this.getBrightness(lightLayer, new ChunkTilePos(x, y, z));
     }
 
-    public void setBrightness(final @NotNull LightLayer lightLayer, final @NotNull ChunkTilePos tilePos, final int value) {
+    public void setBrightness(final @NotNull LightLayer lightLayer, final @NotNull ChunkTilePosc tilePos, final int value) {
         if (!tilePos.inBounds()) {
             return;
         }
 
-        Objects.requireNonNull(this.getSection(tilePos)).setBrightness(lightLayer, tilePos.toChunkSectionTilePos(), value);
+        Objects.requireNonNull(this.getSection(tilePos)).setBrightness(lightLayer, new ChunkSectionTilePos(tilePos), value);
         this.isModified = true;
     }
 
@@ -516,12 +499,12 @@ public class Chunk
         this.setBrightness(lightLayer, new ChunkTilePos(x, y, z), value);
     }
 
-    public int getRawBrightness(final @NotNull ChunkTilePos tilePos, final int subtractedSkyLight) {
+    public int getRawBrightness(final @NotNull ChunkTilePosc tilePos, final int subtractedSkyLight) {
         if (!tilePos.inBounds()) {
             return 0;
         }
 
-        final int lightValue = Objects.requireNonNull(this.getSection(tilePos)).getRawBrightness(tilePos.toChunkSectionTilePos(), subtractedSkyLight);
+        final int lightValue = Objects.requireNonNull(this.getSection(tilePos)).getRawBrightness(new ChunkSectionTilePos(tilePos), subtractedSkyLight);
         if (lightValue > 0) {
             Chunk.isLit = true;
         }
@@ -535,11 +518,10 @@ public class Chunk
     }
 
     public void addEntity(final @NotNull Entity entity) {
-        hasEntities = true;
-        isModified = true;
+        this.hasEntities = true;
+        this.isModified = true;
         final @NotNull ChunkPos entityChunkPos = new ChunkPos(entity);
-        if(!entityChunkPos.equals(this.pos))
-        {
+        if (!entityChunkPos.equals(this.pos)) {
             LOGGER.warn("Wrong location! {}", entity);
             Thread.dumpStack();
         }
@@ -551,19 +533,17 @@ public class Chunk
         getSection(section).addEntity(entity);
     }
 
-    public void removeEntity(Entity entity)
-    {
+    public void removeEntity(@NotNull Entity entity) {
         removeEntityAtIndex(entity, entity.chunkCoordY);
     }
 
-    public void removeEntityAtIndex(Entity entity, int index)
-    {
+    public void removeEntityAtIndex(@NotNull Entity entity, int index) {
         index = MathHelper.clamp(index, 0, CHUNK_SECTIONS - 1);
         getSection(index).removeEntity(entity);
     }
 
-    public boolean canBlockSeeSky(final @NotNull ChunkTilePos tilePos) {
-        return tilePos.y >= this.getHeightValue(tilePos.x, tilePos.z);
+    public boolean canBlockSeeSky(final @NotNull ChunkTilePosc tilePos) {
+        return tilePos.y() >= this.getHeightValue(tilePos.x(), tilePos.z());
     }
 
     @Deprecated
@@ -571,7 +551,7 @@ public class Chunk
         return this.canBlockSeeSky(new ChunkTilePos(x, y, z));
     }
 
-    public @Nullable TileEntity getTileEntity(final @NotNull ChunkTilePos tilePos) {
+    public @Nullable TileEntity getTileEntity(final @NotNull ChunkTilePosc tilePos) {
         @Nullable TileEntity tileEntity = this.tileEntityMap.get(tilePos);
 
         if (tileEntity == null) {
@@ -579,7 +559,7 @@ public class Chunk
             if (block == null || !block.isEntityTile) {
                 return null;
             } else {
-                block.onBlockPlacedByWorld(this.world, this.pos.x * CHUNK_SIZE_X + tilePos.x, tilePos.y, this.pos.z * CHUNK_SIZE_Z + tilePos.z);
+                block.onBlockPlacedByWorld(this.world, this.pos.x * CHUNK_SIZE_X + tilePos.x(), tilePos.y(), this.pos.z * CHUNK_SIZE_Z + tilePos.z());
                 tileEntity = this.tileEntityMap.get(tilePos);
             }
         }
@@ -600,8 +580,8 @@ public class Chunk
     public void addTileEntity(final @NotNull TileEntity tileEntity) {
         final @NotNull TilePos tilePos = new TilePos(tileEntity.x, tileEntity.y, tileEntity.z);
 
-        this.setTileEntity(tilePos.toChunkTilePos(), tileEntity);
-        if(this.isLoaded) {
+        this.setTileEntity(new ChunkTilePos(tilePos), tileEntity);
+        if (this.isLoaded) {
             this.world.tileEntityList.add(tileEntity);
         }
     }
@@ -609,7 +589,7 @@ public class Chunk
     /**
      * @return True if the specified tile entity was set
      */
-    public boolean setTileEntity(final @NotNull ChunkTilePos tilePos, final @NotNull TileEntity tileEntity) {
+    public boolean setTileEntity(final @NotNull ChunkTilePosc tilePos, final @NotNull TileEntity tileEntity) {
         final @NotNull TilePos worldPos = new TilePos(this.pos, tilePos);
 
         tileEntity.worldObj = this.world;
@@ -623,7 +603,7 @@ public class Chunk
             Thread.dumpStack();
         } else {
             tileEntity.validate();
-            final @Nullable TileEntity previous = this.tileEntityMap.put(tilePos, tileEntity);
+            final @Nullable TileEntity previous = this.tileEntityMap.put(new ChunkTilePos(tilePos), tileEntity);
             if (previous != null) {
                 previous.invalidate();
             }
@@ -642,7 +622,7 @@ public class Chunk
         return this.setTileEntity(new ChunkTilePos(x, y, z), tileEntity);
     }
 
-    public void removeTileEntity(final @NotNull ChunkTilePos tilePos) {
+    public void removeTileEntity(final @NotNull ChunkTilePosc tilePos) {
         if (this.isLoaded) {
             final @Nullable TileEntity tileEntity = this.tileEntityMap.remove(tilePos);
             if (tileEntity != null) {
@@ -656,8 +636,8 @@ public class Chunk
         this.removeTileEntity(new ChunkTilePos(x, y, z));
     }
 
-    public void removeTileEntity(TileEntity tileEntity) {
-        if (this.isLoaded && tileEntity != null && tileEntityMap.containsValue(tileEntity)) {
+    public void removeTileEntity(@Nullable TileEntity tileEntity) {
+        if (this.isLoaded && tileEntity != null && this.tileEntityMap.containsValue(tileEntity)) {
             final @NotNull ChunkTilePos tilePos = new ChunkTilePos(tileEntity.x, tileEntity.y, tileEntity.z);
             this.tileEntityMap.remove(tilePos);
             tileEntity.invalidate();
